//---By 3DSage---
//www.youtube.com/c/3dsage

#include "Servo8Bit.h"
Servo8Bit myServo;  //create a servo object.


//6 possible points
// 0 1
// 2 3
// 4 5
int verts[8][2]= //6 verts values x,y
{
 {-4, 10}, //0=upper left
 { 4, 10}, //1=upper right
 {-4, -2}, //2=middle left
 { 4, -2}, //3=middle right
 {-4,-12}, //4=lower left
 { 4,-12}, //5=lower right
 { 0,  4}, //6=top    dot
 { 0, -7}, //7=bottom dot  
};


int num[11][8]=  //all possible numbers
{
 {1,5,4,0,1,9,9,9}, //0
 {1,5,9,9,9,9,9,9}, //1 
 {0,1,3,2,4,5,9,9}, //2
 {0,1,3,2,3,5,4,9}, //3
 {0,2,3,1,5,9,9,9}, //4
 {1,0,2,3,5,4,9,9}, //5
 {1,0,4,5,3,2,9,9}, //6 
 {0,1,5,9,9,9,9,9}, //7 
 {0,4,5,1,0,2,3,9}, //8 
 {1,0,2,3,1,5,9,9}, //9
 {6,6,7,7,9,9,9,9}, //10 middle dot  
};


typedef struct
{
  int x1,y1,x2,y2; //servo start end position
  int xo;          //x offset
  int h;           //hour
  int m;           //minute
}servo; servo S;

int XC=90;
int YC=85;

void moveServo(int s, int x1,int y1, int x2,int y2) //servo, start end position
{int i,xd,xs,yd,ys,x=0,y=0;
 if(s==0)                                    //x rotate
 {
  xd=x2-x1;                                  //x distance
  if(xd==0){ return;}                        //no x
  if(xd>0){ xs=1;} else{ xs=-1; xd*=-1;}     //x step left or right. We need positive distance
  for(i=0;i<=xd*4;i++)
  {
   myServo.attach(s); myServo.write(XC+x1+(x>>2)+S.xo); delay(50); myServo.detach(); //center + (point 1 + xstep) + x offset 
   x+=xs; 
  }
 }

 if(s==1)                                    //y rotate
 {
  yd=y2-y1;                                  //y distance
  if(yd==0){ return;}                        //no y
  if(yd>=0){ ys=1;} else{ ys=-1; yd*=-1;}    //y step up or down
  for(i=0;i<=yd*4;i++)
  {
   myServo.attach(s); myServo.write(YC+y1+(y>>2)); delay(50); myServo.detach(); //center + (point 1 + ystep) 
   y+=ys; 
  }
 }
}


void printDig(int d)
{int i,v;
 for(i=0;i<8;i++)                                                              //all points that draw this digit
 {
  v=num[d][i];                                                                 //hold this point 1 number
  S.x1=verts[v][0];                                                            //servo point 1 x position
  S.y1=verts[v][1];                                                            //servo point 1 y position
  v=num[d][i+1];                                                               //hold this next point number
  if(v==9){ return;}                                                           //end drawing light off 
  S.x2=verts[v][0];                                                            //servo point 2 x position
  S.y2=verts[v][1];                                                            //servo point 2 y position

  myServo.attach(0); myServo.write(XC+S.x1+S.xo); delay(500); myServo.detach(); //servo 1 
  myServo.attach(1); myServo.write(YC+S.y1     ); delay(500); myServo.detach(); //servo 2  
  digitalWrite(2,HIGH);                                                        //light on 
  moveServo(0, S.x1,0, S.x2,0);                                          //rotate x if needed
  moveServo(1, 0,S.y1, 0,S.y2);                                          //rotate y if needed 
  digitalWrite(2,LOW);
 }
}


void setup()
{ 
 delay(1000);                                                           //delay 
 S.x1=0; S.y1=0; S.x2=0; S.y2=0; S.xo=0; S.h=12; S.m=0;                //init variables  
 pinMode(2,OUTPUT);                                                    //pin 2 is led
 digitalWrite(2,LOW);                                                  //led off
 myServo.attach(0); myServo.write(XC); delay(500); myServo.detach();   //servo 1 find middle
 myServo.attach(1); myServo.write(YC); delay(500); myServo.detach();   //servo 2 find middle   
 delay(2000);                                                          //delay 
}

 
void loop()
{   
 int i,j,v,tm[5];
 v=S.h; tm[1]=v%10; v/=10; tm[0]=v%10; v/=10;                         //save first  2 digits
 tm[2]=10;                                                            //top and bottom dots
 v=S.m; tm[4]=v%10; v/=10; tm[3]=v%10; v/=10;                         //save second 2 digits
 S.xo=-25;
 for(i=0;i<5;i++){ if(i==0 && tm[i]==0){ S.xo=S.xo;} else{ printDig(tm[i]); printDig(tm[i]);} if(i==1 || i==2){ S.xo+=10;} else{ S.xo+=15;} }       //print time digits 
 delay(60000);                                                           //hold after drawing
 S.m+=1; if(S.m>59){ S.m=0; S.h+=1; if(S.h>12){ S.h=1;}}              //minutes 0-59 hours 1-12
}
